//---------------------------------------------------------------------
// SPACE TAPPER: game_bars.c
// by Omar Cornut
//---------------------------------------------------------------------
// Game - Bars
//---------------------------------------------------------------------

//---------------------------------------------------------------------

#define BAR_MAX							(4)

#define BAR_CURVED_PART_LENGTH			IFIX4(12)

//---------------------------------------------------------------------

// Note: several positions are in fixed 12/4 format
typedef struct
{
	s16				x_hoffset;				/* X Offset for bar background hscroll	*/
	fs16			xf1;					/* X Position Start						*/
	fs16			xf2;					/* X Position End						*/
	fs16			yf;						/* Y Position Start						*/
	fs16			xf_player;				/* X Position of Player					*/
	fs16			yf_player;				/* Y Position of Player					*/
	s16				x_tapper;				/* X Position of Tapper                 */
	s16				y_tapper;				/* Y Position of Tapper                 */
	s16 /* s8 */	direction;				/* Bar direction (left/right)			*/
}					t_bar;

t_bar *				bars;					/* Pointer to the set of bars used		*/
t_entity *			bars_entities[BAR_MAX];	/* List of entities on a bar			*/

void				bars_draw(void);
void				bars_entities_clear(void);
void                bars_entities_active_set(int type, int active);
void				bars_entities_update(void);
void				bars_entities_update_priority(void);

//---------------------------------------------------------------------

int					bar_entities_count(int bar_idx, int type);

//---------------------------------------------------------------------

void				bars_vcount_handler(void *userdata);

//---------------------------------------------------------------------
