//---------------------------------------------------------------------
// GBALIB: font.c
// by Omar Cornut
//---------------------------------------------------------------------
// Font	System
//---------------------------------------------------------------------

#include "gbalib.h"

//---------------------------------------------------------------------

// FUNCTION: font_bg_print()
// Print text to given background, using char index as beginning of ASCII font
void		font_bg_print(t_bg *bg, int font_char_idx, int dst_x, int dst_y, char *str)
{
	u16	*	dst;
	u16	*	dst_line;
	u16		char_idx;

	// Calculate destination address
	if (dst_x == -1)
	{
		int len;
		for (len = 0; str[len] != '\0' && str[len] != '\n'; len++);
		dst_line = bg->map + (dst_y << 5);
		dst = dst_line + ((31 - len) >> 1);
	}
	else
	{
		dst_line = bg->map + (dst_x + (dst_y << 5));
		dst = dst_line;
	}
	
	// Print actual	string
	while (*str != '\0')
	{
		if (*str ==	'\n')
		{
			dst_line +=	32;	// FIXME: different background size
			if (dst_x == -1)
			{
				int len;
				str++;
				for (len = 0; str[len] != '\0' && str[len] != '\n'; len++);
				dst = dst_line + ((31 - len) >> 1);
				continue;
			}
			else
			{
				dst	= dst_line;
			}
		}
		else
		{
			char_idx = font_char_idx + *str; //((*str >= 32	&& *str	< 96) ?	*str : '!');
			*dst++ = char_idx;
		}
		str++;
	}
}

// FUNCTION: font_bg_printf()
// Print formatted text to given background, using char index as beginning of ASCII font
void		font_bg_printf(t_bg *bg, int font_char_idx, int dst_x, int dst_y, char *format, ...)
{
	va_list	args;
	char	buf[128]; // Do	we care	about security on a	GBA	? :)
	
	va_start(args, format);
	mvsprintf(buf, format, args);
	font_bg_print(bg, font_char_idx, dst_x, dst_y, buf);
	va_end(args);
}

//---------------------------------------------------------------------
