//---------------------------------------------------------------------
// GBALIB: palette.c
// by Omar Cornut
//---------------------------------------------------------------------
// Palette Manager
//---------------------------------------------------------------------
// Simple helper functions to copy palettes data.
//---------------------------------------------------------------------

#include "gbalib.h"

//---------------------------------------------------------------------
// FUNCTIONS
//---------------------------------------------------------------------

// FUNCTION: palette_copy(u16 *src, u16 *dst)
// Copy an arbitrary number of color
// Note: use DMA_16 since we're likely to copy non 32-bits aligned data using this function
void    palette_copy(u16 *src, u16 *dst, int colors)
{
    DMA_Copy(3, DMA_16_NOW, src, dst, colors);
}

// FUNCTION: palette_copy_16(u16 *src, u16 *dst)
// Copy a 16 colors palette
void    palette_copy_16(u16 *src, u16 *dst)
{
    // FIXME: unroll ?
    DMA_Copy(3, DMA_32_NOW, src, dst, 16 / 2);
}

// FUNCTION: palette_copy_256(u16 *src, u16 *dst)
// Copy a 256 colors palette
void    palette_copy_256(u16 *src, u16 *dst)
{
    DMA_Copy(3, DMA_32_NOW, src, dst, 256 / 2);
}
