//---------------------------------------------------------------------
// GBALIB: profile.h
// by Omar Cornut
//---------------------------------------------------------------------
// Profiling Features
//---------------------------------------------------------------------

// Note: define PROFILE to enable profiling functions
// Note: Some definitions above should be changed to suit your need, and
//       are project/game dependant. Also change the #include in profile.c
//       and recompile the library!
// #define PROFILE

#ifdef PROFILE

// Maximum number of value to store
// Note: no boundchecking is done on overflow
#define PROFILE_BUFFER_SIZE         (16)

// How to get the value
#define PROFILE_VALUE               (REG_VCOUNT)

// Printing parameters
#define PROFILE_POS_X               (21)
#define PROFILE_POS_X_INC           (0)
#define PROFILE_POS_Y               (0)
#define PROFILE_POS_Y_INC           (1)
#define PROFILE_PRINT(_X,_Y,_STR)   font_bg_print(&game.bg3, game.font_char_idx, _X, _Y, _STR)

// Make up an integer out of a 4-character string
#define PROFILE_DESC(STR)           (STR[0]|(STR[1]<<8)|(STR[2]<<16)|(STR[3]<<24))
#define profile_now(STR)            profile_now2((int)PROFILE_DESC(STR))

//---------------------------------------------------------------------
// FUNCTIONS
//---------------------------------------------------------------------

void            profile_start(void);
void            profile_now2(int desc);
void            profile_print(void);

//---------------------------------------------------------------------

#endif /* #ifdef PROFILE */
