//---------------------------------------------------------------------
// SPACE TAPPER: sections.h
// by Omar Cornut
//---------------------------------------------------------------------
// Sections / Section Manager
//---------------------------------------------------------------------

//---------------------------------------------------------------------

#define SECTIONS_STACK_SIZE		(4)

//---------------------------------------------------------------------

#define SECTION_INTERFACE_TITLE_SCREEN	(0)
#define SECTION_INTERFACE_LEVEL_SELECT	(1)
#define SECTION_INTERFACE_GAME_OVER		(2)
#define SECTION_INTERFACE_LEVEL_END		(3)
#define SECTION_GAME_MAIN				(4)
#define SECTION_EFFECTS					(5)
#define SECTION_MAX						(6)

typedef struct
{
	void	(*f_start)	(va_list args);
	void	(*f_update)	(void);
	void	(*f_stop)	(void);
}			ts_section;

//---------------------------------------------------------------------

// Section
typedef struct
{
	int				id;
	ts_section *	data;
}					t_section;

// Section Manager
typedef struct
{
	t_section		stack[SECTIONS_STACK_SIZE];
	int				stack_pos;
	t_section *		current;
}					t_sections;

extern t_sections	sections;
	
//---------------------------------------------------------------------

void    			sections_init(void);

//---------------------------------------------------------------------

void				section_jump(int id, ...);
void				section_call(int id, ...);
void				section_return(void);

//---------------------------------------------------------------------
