//---------------------------------------------------------------------
// SPACE TAPPER: tapper.h
// by Omar Cornut
//---------------------------------------------------------------------
// Main File
//---------------------------------------------------------------------

// PROJECT INFORMATIONS -----------------------------------------------
// FIXME: Need to instance those strings somewhere at the beginning of the ROM.
#define PROJECT_NAME					"SPACE TAPPER"
#define PROJECT_DATE					"2004.01.07" // __DATE__
#define PROJECT_AUTHORS					"ANDRE BERUBE & OMAR CORNUT"
#define PROJECT_AUTHORS_DESC			"GFX: A.BERUBE - CODE: O.CORNUT"

// INCLUDES (LIBRARY) -------------------------------------------------
#include "gbalib.h"						/* GBA Library				    	*/

// INCLUDES (GAME) ----------------------------------------------------
// FIXME: Include ordering is currently important. Should resolve those conflicts.
#include "game_entity.h"				/* Game - Entity 					*/
#include "game_entity_beers.h"			/* Game - Entity - Beers			*/
#include "game_entity_customers.h"		/* Game - Entity - Customers		*/
#include "game_entity_money.h"	    	/* Game - Entity - Money	    	*/
#include "game_misc.h"					/* Game - Miscellaneous				*/
#include "game_special_entertainers.h"	/* Game - Special - Entertainers	*/
#include "game_special_tubealien.h"		/* Game - Special - Tube Alien		*/
#include "game_tappers.h"           	/* Game - Tappers               	*/
#include "game_bars.h"					/* Game - Bars						*/
#include "game_player.h"				/* Game - Player					*/
#include "game_levels.h"				/* Game - Levels					*/
#include "game_levels_sequencer.h"		/* Game - Levels - Sequencer    	*/
#include "game_state.h"					/* Game - State						*/
#include "game.h"						/* Game								*/
#include "effects.h"					/* Effects							*/
#include "inputs.h"						/* Inputs							*/
#include "interface_game_over.h"		/* Interface - Game Over			*/
#include "interface_level_end.h"		/* Interface - Level End			*/
#include "interface_level_select.h"		/* Interface - Level Select			*/
#include "interface_title.h"			/* Interface - Title Screen			*/
#include "sections.h"					/* Sections							*/

// INCLUDES (DATA) ----------------------------------------------------
#include "data.h"						/* Data								*/
#include "data_levels.h"        	    /* Data - Levels                	*/

// FUNCTIONS ----------------------------------------------------------
int		rand(void);						/* rand() from LibC (avoid use)		*/
void	fatal(char *msg);				/* in tapper.c						*/
void    font_init_videodata(void);

//---------------------------------------------------------------------
