/*
** list_add.c for liblist2 in 
** 
** Made by omar cornut
** Login   <cornut_o@epita.fr>
** 
** Started on  Tue Apr 24 18:37:54 2001 omar cornut
** Last update Sun Apr 28 22:57:10 2002 omar cornut
*/

//-------------------------------------------------------------------

#include "list.h"

void *malloc(int);
void free(void *);

//-------------------------------------------------------------------

void		list_add_to_end(t_list **list, void *elem)
{
  t_list	*new;
  t_list	*list2;

  new = malloc(sizeof (t_list));
  new->elem = elem;
  new->next = 0;
  if (*list == 0)
    *list = new;
  else
    {
      list2 = *list;
      while (list2->next)
	list2 = list2->next;
      list2->next = new;
    }
}

void            list_free_custom(t_list **list, void (*custom_free)())
{
  t_list	*next;
  
  while (*list)
    {
      next = (*list)->next;
      if (custom_free)
	custom_free((*list)->elem);
      free(*list);
      *list = next;
    }
}

int		list_size(t_list *list)
{
  int		cnt;

  cnt = 0;
  while (list)
    {
      cnt += 1;
      list = list->next;
    }
  return (cnt);
}

//-------------------------------------------------------------------
